Name:          commoncpp2
Version:       1.8.1
Release:    2%{?dist}
Summary:       GNU Common C++ class framework

License:       GPLv2+ with exceptions
URL:           http://www.gnu.org/software/commoncpp/
Source0:       https://ftp.gnu.org/gnu/commoncpp/%{name}-%{version}.tar.gz

Patch1:        commoncpp2-statfix.patch
Patch2:        commoncpp2-gcc9.patch
Patch3:        commoncpp2_sizeof.patch
Patch4:        commoncpp2_obsoletem4.patch
Patch5:        commoncpp2_setgroups.patch
Patch6:        commoncpp2_tests.patch

BuildRequires: automake autoconf libtool
BuildRequires: doxygen
BuildRequires: gcc
BuildRequires: gcc-c++
BuildRequires: libxml2-devel
BuildRequires: zlib-devel
BuildRequires: make


%description
GNU Common C++ is a portable and highly optimized class framework for writing
C++ applications that need to use threads, sockets, XML parsing,
serialization, config files, etc. This framework offers a class foundation
that hides platform differences from your C++ application so that you need
not write platform specific code. GNU Common C++ has been ported to compile
natively on most platforms which support posix threads.


%package devel
Summary:       Header files and libraries for %{name} development
Requires:      %{name} = %{version}-%{release}
Requires:      libxml2-devel
Requires:      zlib-devel

%description devel
The %{name}-devel package contains the header files and libraries needed
to develop programs that use the %{name} library.


%package doc
Summary:       Developer documentation for %{name}
License:       GPLv2+ with exceptions and GFDL
BuildArch:     noarch

%description doc
The %{name}-doc package contains the developer documentation for %{name}.


%prep
%autosetup -p1


%build
autoreconf -ifv
%configure \
    --disable-static \
    --disable-dependency-tracking

sed -e 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' \
    -e 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' \
    -e 's|CC="\(g..\)"|CC="\1 -Wl,--as-needed"|' \
    -i libtool

make CXX="g++ -std=c++14"

pushd tests
%make_build CXX="g++ -std=c++14"
popd


%install
%make_install
find %{buildroot} -name '*.la' -delete

rm -f %{buildroot}%{_infodir}/dir

%check
pushd tests
LD_LIBRARY_PATH=%{buildroot}%{_libdir} ./test.sh
popd


%files
%doc README ChangeLog
%license COPYING
%{_libdir}/*.so.*

%files devel
%{_bindir}/ccgnu2-config
%{_includedir}/cc++/
%{_libdir}/*.so
%{_libdir}/pkgconfig/libccext2.pc
%{_libdir}/pkgconfig/libccgnu2.pc
%{_datadir}/aclocal/ost_check2.m4

%files doc
%doc doc/html
%{_infodir}/commoncpp2.info*

%changelog
* Wed Jun 04 2025 bbrucezhang <bbrucezhang@tencent.com> - 1.8.1-2
- Rebuilt for loongarch64

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.1-1
- initial build
